Hi,

here is my port of screen 3.5.2 to Mint.
To get it running I had to make some adaptions:

- Implement Mint style pty's (inspired by Kay Roemer's portlib).
- Circumvent the "Mint has no real fork()" problem.
  I did this simply by omitting the main fork() call which splits of
  the so-called attacher. So there will be no attacher running!
- Re-implement the locking mechanism, since the attacher took care of that.
  To lock the screen, a separate process will be started (lockscreen).

In practice this means that you cannot detach screen, i.e. putting the
entire screen session in the background. This would enable one to logout
while foreground processes keep running. Since most of us turn off their
Atari after they logout, we will not miss this feature.

I did not adapt the manual, so you must skip all references to
detaching and (multiple) attaching.
In particular, the options -r, -R, -d, -D, -wipe, -ls, -x and -m are
disabled.

Prior to this version, I did a port which incorporated these features.
The fork problem was circumvented by having two screen programs running at
the same time, one behaving as the attacher.
It ran great, but used 600K of memory (constantly!), while this port uses
only 220K and misses some features you would probably never use anyway!

Three last remarks:

- I included a file with the diffs from the original distribution of
  screen 3.5.2. People wanting to recompile screen need sed, awk, gcc
  and the termcap and portlib libraries.
  The included binaries were compiled with gcc 2.5.8 and mintlibs PL44.

- To run screen on a terminal connect to your Atari through a serial line,
  you need my patch to mint 1.10h8, which will probably be incorporated in
  mint 1.10h9.

- It is not yet possible to start GEM from within screen.
  I think this would be possible by copying some parts of Juergen Lock's
  virtual terminal program. I will do this as soon as I know how.

To install:

- make sure you are root (e.g. by running "su").
- copy "screen" to /usr/local/bin (or wherever you like it).
  set the user s-bit of screen: chmod u+s /usr/local/bin/screen
- copy "screenlock" to /usr/local/bin (if you put it somewhere else, make
  sure that location is in your PATH variable).
- copy "screenrc" to /usr/local/etc (if you put it somewhere else, set
  the environment variable SYSSCREENRC to the full filename).
- copy "screen.1" to /usr/local/man/man1 (or wherever you keep your manuals).
  I also included a preformatted manpage "screen.nr" (which is normally
  installed in /usr/local/man/cat1).
- insert the file "screencap" into /etc/termcap (preferably at the start).

Any comments, suggestions and bugreports to,

Richard Huveneers
huveneer@math.ruu.nl
